unit RRPGDBExRichEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Graphics,
  ComCtrls, Forms, StdCtrls, ExtCtrls, CommCtrl, RichEdit, RichOle,
  ShellApi, Menus, ActiveX, RRPGRichEdit, DB, DBCtrls, RRPGControls,
  RRPGDBRichEdit, RRPGFrameExDBRichEdit;

type
  TRExDBRichEdit = class(TRPanelCustomizado)
  private
    FReadOnly: Boolean;
    FDataSource: TDataSource;
    FDataField: WideString;
    FFrame: TfraFrameExDBRichEdit;
  protected
    procedure CriarComponentes; virtual;
    procedure ConfigurarVisual; override;

    procedure SetDataField(const Value: WideString);
    procedure SetDataSource(Value: TDataSource);
    procedure SetReadOnly(Value: Boolean);

    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property DataField: WideString read FDataField write SetDataField;
    property DataSource: TDataSource read FDataSource write SetDataSource;
    property ReadOnly: Boolean read FReadOnly write SetReadOnly default False;
  end;

implementation

{ TRExDBRichEdit }

procedure TRExDBRichEdit.ConfigurarVisual;
begin
  inherited;
  Self.Color := clWhite;
end;


constructor TRExDBRichEdit.Create(AOwner: TComponent);
begin
  inherited;

  if not (csDesigning in Self.ComponentState) then
  begin
    Self.CriarComponentes();
  end;
end;

procedure TRExDBRichEdit.CriarComponentes;
begin
  FFrame := TfraFrameExDBRichEdit.Create(nil);
  FFrame.Align := alClient;
  FFrame.Visible := True;
  FFrame.Parent := Self;
end;

destructor TRExDBRichEdit.Destroy;
begin
  FreeAndNil(FFrame);
  inherited;
end;

procedure TRExDBRichEdit.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;

  if (Operation = opRemove) and (AComponent = DataSource) then
    DataSource := nil;
end;

procedure TRExDBRichEdit.SetDataField(const Value: WideString);
begin
  if FDataField <> Value then
  begin
    FDataField := Value;

    if FFrame <> nil then
      FFrame.DataField := FDataField;
  end;
end;

procedure TRExDBRichEdit.SetDataSource(Value: TDataSource);
begin
  if FDataSource <> Value then
  begin
    if FDataSource <> nil then
      FDataSource.RemoveFreeNotification(Self);

    FDataSource := Value;

    if Value <> nil then
      Value.FreeNotification(Self);

    if FFrame <> nil then
      FFrame.DataSource := Value;
  end;
end;

procedure TRExDBRichEdit.SetReadOnly(Value: Boolean);
begin
  if FReadOnly <> Value then
  begin
    FReadOnly := Value;

    if FFrame <> nil then
      FFrame.ReadOnly := FReadOnly;
  end;
end;

end.
