unit RRPGFrameExDBRichEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, DB, RRPGDBRichEdit, RRPGRichEdit, ToolWin, ComCtrls, ActnList,
  ImgList, RichEdit, ExtCtrls, StdCtrls, ActiveX, RichOLE;

type
  TRDBRichEditFrame = class(TRDBRichEdit)
  protected
    procedure BeforeSalvarNoDataSet; override;
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TfraFrameExDBRichEdit = class(TFrame)
    barTools: TToolBar;
    aclRich: TActionList;
    btnBold: TToolButton;
    btnItalico: TToolButton;
    imlRich: TImageList;
    btnUnderline: TToolButton;
    actBold: TAction;
    actItalico: TAction;
    actUnderline: TAction;
    tmrGetCharFormat: TTimer;
    btnSep1: TToolButton;
    btnAlignLeft: TToolButton;
    btnAlignCenter: TToolButton;
    btnAlignRight: TToolButton;
    actAlignLeft: TAction;
    actAlignCenter: TAction;
    actAlignRight: TAction;
    btnSep2: TToolButton;
    cmbFontes: TComboBox;
    tmrLoad: TTimer;
    btnSep3: TToolButton;
    cmbTamanho: TComboBox;
    btnSep4: TToolButton;
    actBullets: TAction;
    btnBullets: TToolButton;
    actIdent: TAction;
    actRemoverIdent: TAction;
    btnIdent: TToolButton;
    btnDeIdent: TToolButton;
    actCor: TAction;
    btnCor: TToolButton;
    clgCor: TColorDialog;
    actInsImg: TAction;
    ToolButton1: TToolButton;
    btnImagem: TToolButton;
    btnAlignJustify: TToolButton;
    actAlignJustify: TAction;
    procedure actBoldExecute(Sender: TObject);
    procedure actItalicoExecute(Sender: TObject);
    procedure actUnderlineExecute(Sender: TObject);
    procedure tmrGetCharFormatTimer(Sender: TObject);
    procedure actAlignLeftExecute(Sender: TObject);
    procedure actAlignCenterExecute(Sender: TObject);
    procedure actAlignRightExecute(Sender: TObject);
    procedure RichEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tmrLoadTimer(Sender: TObject);
    procedure cmbFontesKeyPress(Sender: TObject; var Key: Char);
    procedure cmbFontesCloseUp(Sender: TObject);
    procedure cmbTamanhoCloseUp(Sender: TObject);
    procedure cmbTamanhoKeyPress(Sender: TObject; var Key: Char);
    procedure cmbFontesSelect(Sender: TObject);
    procedure cmbTamanhoSelect(Sender: TObject);
    procedure actBulletsExecute(Sender: TObject);
    procedure actIdentExecute(Sender: TObject);
    procedure actRemoverIdentExecute(Sender: TObject);
    procedure actCorExecute(Sender: TObject);
    procedure actInsImgExecute(Sender: TObject);
    procedure actAlignJustifyExecute(Sender: TObject);
  private
    FRich: TRDBRichEditFrame;
    FIRich: IRichEditOle;


    function GetDataField: WideString;
    function GetDataSource: TDataSource;
    function GetReadOnly: Boolean;
    procedure SetDataField(const Value: WideString);
    procedure SetDataSource(const Value: TDataSource);
    procedure SetReadOnly(const Value: Boolean);

    // Eventos
    procedure OnSelectionChange(Sender: TObject);
    procedure OnChange(Sender: TObject);
  protected
    procedure AtualizarAtualCharFormat; virtual;
    procedure ListarFontes; virtual;
    procedure Loaded; override;

    procedure AplicarFonteFace(const Nome: String);
    procedure AplicarTamanhoFonte(const Tamanho: Integer);

    procedure InserirOleObject(DatO: IOleObject; GUIDClasse: TGUID); virtual;
    procedure PrepararRichEdit; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    property DataField: WideString read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property ReadOnly: Boolean read GetReadOnly write SetReadOnly;
    property RichEdit: TRDBRichEditFrame read FRich;
  end;

const
  IDENT_COUNT = 350;

implementation

uses RRPGModuloUtil, RRPGActiveX_TLB, TextObjectModel;

{$R *.dfm}

{ TfraFrameExDBRichEdit }

procedure TfraFrameExDBRichEdit.actAlignCenterExecute(Sender: TObject);
var
  P: TParaFormat2;
begin
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_ALIGNMENT;
  P.wAlignment := PFA_CENTER;

  if SendMessage(FRich.Handle, EM_SETPARAFORMAT, 0, Integer(@P)) <> 0 then
  begin
    actAlignLeft.Checked := False;
    actAlignCenter.Checked := True;
    actAlignRight.Checked := False;
    actAlignJustify.Checked := False;
  end;
end;

procedure TfraFrameExDBRichEdit.actAlignJustifyExecute(Sender: TObject);
var
  P: TParaFormat2;
begin
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_ALIGNMENT;
  P.wAlignment := PFA_JUSTIFY;

  if SendMessage(FRich.Handle, EM_SETPARAFORMAT, 0, Integer(@P)) <> 0 then
  begin
    actAlignLeft.Checked := False;
    actAlignCenter.Checked := False;
    actAlignRight.Checked := False;
    actAlignJustify.Checked := True;
  end;
end;

procedure TfraFrameExDBRichEdit.actAlignLeftExecute(Sender: TObject);
var
  P: TParaFormat2;
begin
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_ALIGNMENT;
  P.wAlignment := PFA_LEFT;

  if SendMessage(FRich.Handle, EM_SETPARAFORMAT, 0, Integer(@P)) <> 0 then
  begin
    actAlignLeft.Checked := True;
    actAlignCenter.Checked := False;
    actAlignRight.Checked := False;
    actAlignJustify.Checked := False;
  end;
end;

procedure TfraFrameExDBRichEdit.actAlignRightExecute(Sender: TObject);
var
  P: TParaFormat2;
begin
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_ALIGNMENT;
  P.wAlignment := PFA_RIGHT;

  if SendMessage(FRich.Handle, EM_SETPARAFORMAT, 0, Integer(@P)) <> 0 then
  begin
    actAlignLeft.Checked := False;
    actAlignCenter.Checked := False;
    actAlignRight.Checked := True;
    actAlignJustify.Checked := False;
  end;
end;

procedure TfraFrameExDBRichEdit.actBoldExecute(Sender: TObject);
var
  F: TCharFormat2;
begin
  FillChar(F, SizeOf(F), 0);
  F.cbSize := SizeOf(F);
  F.dwMask := CFM_BOLD;

  if not actBold.Checked then
    F.dwEffects := CFE_BOLD;

  if SendMessage(FRich.Handle, EM_SETCHARFORMAT, SCF_SELECTION, Integer(@F)) <> 0 then
    actBold.Checked := not actBold.Checked;
end;

procedure TfraFrameExDBRichEdit.actBulletsExecute(Sender: TObject);
var
  P: TParaFormat2;
begin
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_NUMBERING;

  if not actBullets.Checked then
    P.wNumbering := PFN_BULLET
  else
    P.wNumbering := 0;

  if SendMessage(FRich.Handle, EM_SETPARAFORMAT, 0, Integer(@P)) <> 0 then
    actBullets.Checked := not actBullets.Checked;
end;

procedure TfraFrameExDBRichEdit.actCorExecute(Sender: TObject);
var
  C: TCharFormat2;
begin
  FillChar(C, SizeOf(C), 0);
  C.cbSize := SizeOf(C);
  C.dwMask := CFM_COLOR;

  SendMessage(FRich.Handle, EM_GETCHARFORMAT, SCF_SELECTION, Integer(@C));

  clgCor.Color := C.crTextColor;

  if clgCor.Execute(Self.Handle) then
  begin
    FillChar(C, SizeOf(C), 0);
    C.cbSize := SizeOf(C);
    C.dwMask := CFM_COLOR;
    C.crTextColor := clgCor.Color;
    SendMessage(FRich.Handle, EM_SETCHARFORMAT, SCF_SELECTION, Integer(@C));
  end;
end;

procedure TfraFrameExDBRichEdit.actIdentExecute(Sender: TObject);
var
  P: TParaFormat2;
begin
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_STARTINDENT;

  SendMessage(FRich.Handle, EM_GETPARAFORMAT, 0, Integer(@P));

  P.cbSize := SizeOf(P);
  P.dwMask := PFM_STARTINDENT;
  P.dxStartIndent := P.dxStartIndent + IDENT_COUNT;

  SendMessage(FRich.Handle, EM_SETPARAFORMAT, 0, Integer(@P));
end;

procedure TfraFrameExDBRichEdit.actInsImgExecute(Sender: TObject);
var
  URL: String;
  Img: ITCoWinURLImage;
  R: Integer;
  O: IOleObject;
begin
  if Self.ReadOnly then
    Abort;

  if FRich.DataSource <> nil then
    if FRich.DataSource.DataSet <> nil then
      if not FRich.DataSource.DataSet.CanModify then
        Exit;

  if ObterURLParaUmaImagem(URL) then
  begin
    Img := nil;

    R := CoCreateInstance(CLASS_TCoWinURLImage, nil, CLSCTX_INPROC_SERVER,
                          IID_ITCoWinURLImage, Img);

    if not Succeeded(R) then
    begin
      if R = REGDB_E_CLASSNOTREG then
        raise Exception.Create('No foi possvel encontrar a classe TCoWinURLImage '+
                                'no seu computador. Reinstalar o RRPG Firecast ir resolver o problema');

      RaiseLastOSError;
    end;

    Img.URLImagem := Url;
    Img.OtimizarDesenho := False;
    Img.BoaQualidade := False;

    Img.Center := True;
    Img.Proporcional := True;
    Img.Stretch := False;

    O := Img as IOleObject;

    OleSetContainedObject(O, True);

    if not FRich.BeginEditing then
      Exit;

    Self.InserirOleObject(O, CLASS_TCoWinURLImage);
  end;
end;

procedure TfraFrameExDBRichEdit.actItalicoExecute(Sender: TObject);
var
  F: TCharFormat2;
begin
  FillChar(F, SizeOf(F), 0);
  F.cbSize := SizeOf(F);
  F.dwMask := CFM_ITALIC;

  if not actItalico.Checked then
    F.dwEffects := CFE_ITALIC;

  if SendMessage(FRich.Handle, EM_SETCHARFORMAT, SCF_SELECTION, Integer(@F)) <> 0 then
    actItalico.Checked := not actItalico.Checked;
end;

procedure TfraFrameExDBRichEdit.actRemoverIdentExecute(Sender: TObject);
var
  P: TParaFormat2;
begin
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_STARTINDENT;

  SendMessage(FRich.Handle, EM_GETPARAFORMAT, 0, Integer(@P));

  P.cbSize := SizeOf(P);
  P.dwMask := PFM_STARTINDENT;
  P.dxStartIndent := P.dxStartIndent - IDENT_COUNT;

  if P.dxStartIndent < 0 then
    P.dxStartIndent := 0;

  SendMessage(FRich.Handle, EM_SETPARAFORMAT, 0, Integer(@P));
end;

procedure TfraFrameExDBRichEdit.actUnderlineExecute(Sender: TObject);
var
  F: TCharFormat2;
begin
  FillChar(F, SizeOf(F), 0);
  F.cbSize := SizeOf(F);
  F.dwMask := CFM_UNDERLINE;

  if not actUnderline.Checked then
    F.dwEffects := CFE_UNDERLINE;

  if SendMessage(FRich.Handle, EM_SETCHARFORMAT, SCF_SELECTION, Integer(@F)) <> 0 then
    actUnderline.Checked := not actUnderline.Checked;
end;

procedure TfraFrameExDBRichEdit.AplicarFonteFace(const Nome: String);
var
  F: TCharFormat2;
  L: Integer;
  StrX: WideString;
begin
  FillChar(F, SizeOf(F), 0);
  F.cbSize := SizeOf(F);
  F.dwMask := CFM_FACE;

  StrX := WideString(Nome);
  L := Length(StrX);

  if L > 31 then
    L := 31;

  Move(StrX[1], F.szFaceName[0], L * SizeOf(Char));
  SendMessage(FRich.Handle, EM_SETCHARFORMAT, SCF_SELECTION, Integer(@F));
end;

procedure TfraFrameExDBRichEdit.AplicarTamanhoFonte(const Tamanho: Integer);
var
  F: TCharFormat2;
begin
  FillChar(F, SizeOf(F), 0);
  F.cbSize := SizeOf(F);
  F.dwMask := CFM_SIZE;
  F.yHeight := Tamanho * 20;
  SendMessage(FRich.Handle, EM_SETCHARFORMAT, SCF_SELECTION, Integer(@F));
end;

procedure TfraFrameExDBRichEdit.AtualizarAtualCharFormat;
var
  F: TCharFormat2;
  P: TParaFormat2;
  Txt, TamStr: String;
begin
  // Fonte
  FillChar(F, SizeOf(F), 0);
  F.cbSize := SizeOf(F);
  F.dwMask := CFM_BOLD or CFM_ITALIC or CFM_UNDERLINE or CFM_FACE or CFM_SIZE;

  SendMessage(FRich.Handle, EM_GETCHARFORMAT, SCF_SELECTION, Integer(@F));

  actBold.Checked := F.dwEffects and CFE_BOLD <> 0;
  actItalico.Checked := F.dwEffects and CFE_ITALIC <> 0;
  actUnderline.Checked := F.dwEffects and CFE_UNDERLINE <> 0;

  Txt := Trim(PChar(@F.szFaceName[0]));

  if cmbFontes.Text <> Txt then
    cmbFontes.Text := Txt;

  TamStr := IntToStr(F.yHeight div 20);

  if cmbTamanho.Text <> TamStr then
    cmbTamanho.Text := TamStr;

  // Pargrafo
  FillChar(P, SizeOf(P), 0);
  P.cbSize := SizeOf(P);
  P.dwMask := PFM_ALIGNMENT or PFM_NUMBERING;

  SendMessage(FRich.Handle, EM_GETPARAFORMAT, 0, Integer(@P));

  case P.wAlignment of
    PFA_RIGHT:
    begin
      actAlignLeft.Checked := False;
      actAlignCenter.Checked := False;
      actAlignRight.Checked := True;
      actAlignJustify.Checked := False;
    end;

    PFA_CENTER:
    begin
      actAlignLeft.Checked := False;
      actAlignRight.Checked := False;
      actAlignCenter.Checked := True;
      actAlignJustify.Checked := False;
    end;

    PFA_JUSTIFY:
    begin
      actAlignCenter.Checked := False;
      actAlignRight.Checked := False;
      actAlignLeft.Checked := False;
      actAlignJustify.Checked := True;
    end;

    else
    begin
      actAlignCenter.Checked := False;
      actAlignRight.Checked := False;
      actAlignLeft.Checked := True;
      actAlignJustify.Checked := False;
    end;
  end;

  actBullets.Checked := P.wNumbering = PFN_BULLET;
end;

procedure TfraFrameExDBRichEdit.cmbFontesCloseUp(Sender: TObject);
begin
  FRich.SetFocus;
end;

procedure TfraFrameExDBRichEdit.cmbFontesKeyPress(Sender: TObject;
  var Key: Char);
begin

  case Key of
    #13:
    begin
      Self.AplicarFonteFace(cmbFontes.Text);
      FRich.SetFocus;
      Key := #0;
    end;
  end;
end;

procedure TfraFrameExDBRichEdit.cmbFontesSelect(Sender: TObject);
begin
  Self.AplicarFonteFace(cmbFontes.Text);
end;

procedure TfraFrameExDBRichEdit.cmbTamanhoCloseUp(Sender: TObject);
begin
  FRich.SetFocus;
end;

procedure TfraFrameExDBRichEdit.cmbTamanhoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (CharInSet(Key, ['0'..'9', #13, #6, #8])) then
  begin
    Key := #0;
    Exit;
  end;

  case Key of
    #13:
    begin
      Self.AplicarTamanhoFonte(StrToIntDef(cmbTamanho.Text, 8));
      FRich.SetFocus;
      Key := #0;
    end;
  end;
end;

procedure TfraFrameExDBRichEdit.cmbTamanhoSelect(Sender: TObject);
begin
  Self.AplicarTamanhoFonte(StrToIntDef(cmbTamanho.Text, 8));
end;

constructor TfraFrameExDBRichEdit.Create(AOwner: TComponent);
begin
  inherited;
  FRich := TRDBRichEditFrame.Create(nil);
  FRich.Align := alClient;
  FRich.OnSelectionChange := Self.OnSelectionChange;
  FRich.OnChange := Self.OnChange;
  FRich.OnKeyDown := Self.RichEditKeyDown;
  FRich.Parent := Self;
  FRich.Font.Size := 10;
  FRich.InicializarComponente();

  Self.PrepararRichEdit();
end;

destructor TfraFrameExDBRichEdit.Destroy;
begin
  FreeAndNil(FRich);
  inherited;
end;

function TfraFrameExDBRichEdit.GetDataField: WideString;
begin
  Result := FRich.DataField;
end;

function TfraFrameExDBRichEdit.GetDataSource: TDataSource;
begin
  Result := FRich.DataSource;
end;

function TfraFrameExDBRichEdit.GetReadOnly: Boolean;
begin
  Result := FRich.ReadOnly;
end;

procedure TfraFrameExDBRichEdit.InserirOleObject(DatO: IOleObject; GUIDClasse: TGUID);
var
  Obj: TREOBJECT;
  Form: formatetc;
  Site: IOleClientSite;
begin
  FIRich := nil;
  SendMessage(FRich.Handle, EM_GETOLEINTERFACE, 0, LParam(@FIRich));

  FillChar(Form, SizeOf(Form), 0);
  Form.cfFormat := 0;
  Form.dwAspect := DVASPECT_CONTENT;
  Form.lindex := -1;
  Form.tymed := TYMED_NULL;

  FIRich.GetClientSite(Site);

  Initialize(Obj);
  FillChar(Obj, SizeOf(Obj), 0);
  Obj.cbStruct := SizeOf(Obj);
  Obj.clsid := GUIDClasse;
	Obj.cp := Longint(REO_CP_SELECTION);
	Obj.dvaspect := DVASPECT_CONTENT;
	Obj.dwFlags := REO_BELOWBASELINE or REO_RESIZABLE;
	Obj.dwUser := 0;
	Obj.oleobj := DatO;
  Obj.stg := FRich.Storage;
  Obj.olesite := Site;

  if not Succeeded(FIRich.InsertObject(Obj)) then
    RaiseLastOSError;
end;

function EnumFontesCallback(L: PLogFont; Metrica: PTextMetric; FontType: DWORD;
                           Frame: TfraFrameExDBRichEdit): Integer; stdcall;
var
  Str: String;
begin
  Result := 1;

  if FontType <> TRUETYPE_FONTTYPE then
    Exit;


  Str := Trim(PChar(@L.lfFaceName[0]));

  if Str = '' then
    Exit;

  if Str[1] = '@' then
    Exit;

  Frame.cmbFontes.Items.Add(Str);
end;

procedure TfraFrameExDBRichEdit.ListarFontes;
var
  DC: HDC;
  L: TLogFont;
begin
  cmbFontes.Items.BeginUpdate;

  try
    cmbFontes.Items.Clear;

    DC := GetDC(FRich.Handle);

    try
      FillChar(L, SizeOf(L), 0);
      L.lfCharSet := ANSI_CHARSET;

      EnumFontFamilies(DC, nil, @EnumFontesCallback, Integer(Self));
    finally
      ReleaseDC(FRich.Handle, DC);
    end;

    cmbFontes.Sorted := True;
  finally
    cmbFontes.Items.EndUpdate;
  end;
end;

procedure TfraFrameExDBRichEdit.Loaded;
begin
  inherited;

end;

procedure TfraFrameExDBRichEdit.OnChange(Sender: TObject);
begin
  tmrGetCharFormat.Enabled := True;
end;

procedure TfraFrameExDBRichEdit.OnSelectionChange(Sender: TObject);
begin
  tmrGetCharFormat.Enabled := True;
end;

procedure TfraFrameExDBRichEdit.PrepararRichEdit;
begin
end;

procedure TfraFrameExDBRichEdit.RichEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Shift = [ssCtrl] then
    case Key of
      Ord('B'), Ord('b'): actBold.Execute;
      Ord('I'), Ord('i'):
      begin
        actItalico.Execute;
        Key := 0;
      end;

      Ord('U'), Ord('u'): actUnderline.Execute;
    end;
end;

procedure TfraFrameExDBRichEdit.SetDataField(const Value: WideString);
begin
  FRich.DataField := Value;
end;

procedure TfraFrameExDBRichEdit.SetDataSource(const Value: TDataSource);
begin
  FRich.DataSource := Value;
end;

procedure TfraFrameExDBRichEdit.SetReadOnly(const Value: Boolean);
begin
  FRich.ReadOnly := Value;
end;

procedure TfraFrameExDBRichEdit.tmrGetCharFormatTimer(Sender: TObject);
begin
  tmrGetCharFormat.Enabled := False;
  Self.AtualizarAtualCharFormat();
end;

procedure TfraFrameExDBRichEdit.tmrLoadTimer(Sender: TObject);
begin
  tmrLoad.Enabled := False;
  Self.ListarFontes();
end;

{ TRDBRichEditFrame }

function RectIntersects(R1, R2: TRect): Boolean;
begin
  Result := not ( (R1.BottomRight.X < R2.TopLeft.X) or
                  (R1.BottomRight.Y < R2.TopLeft.Y) or
                  (R2.BottomRight.X < R1.TopLeft.X) or
                  (R2.BottomRight.Y < R1.TopLeft.Y) );
end;

procedure TRDBRichEditFrame.BeforeSalvarNoDataSet;
  procedure ApagarObjetosInapropriados;
  var
    i: Integer;
    RE: TREOBJECT;
    clsidNULL: TGUID;
    PossuiRectParaAvisar, DeletouObjeto: Boolean;
    RectObjetoDeletado: TRect;
    Rng: CHARRANGE;
    PtScreen: TPoint;
  begin
    RectObjetoDeletado := Rect(0, 0, 0, 0);
    PossuiRectParaAvisar := False;
    DeletouObjeto := False;
    FillChar(clsidNULL, SizeOf(clsidNULL), 0);

    for i := Self.RichOle.GetObjectCount - 1 downto 0 do
    begin
      Finalize(RE);
      FillChar(RE, SizeOf(RE), 0);
      RE.cbStruct := SizeOf(RE);

      if not Succeeded(Self.RichOle.GetObject(i, RE, REO_GETOBJ_ALL_INTERFACES)) then
        Continue;

      if IsEqualGUID(RE.clsid, CLASS_TCoWinURLImage) then
        Continue;

      Self.RichOle.HandsOffStorage(i);
      DeletouObjeto := True;

      if not PossuiRectParaAvisar then
      begin
        Rng.cpMin := RE.cp;
        Rng.cpMax := Rng.cpMin + 1;
        RectObjetoDeletado := Self.GetClientRectForRange(Rng);

        if RectIntersects(RectObjetoDeletado, Self.ClientRect) then
        begin
          PtScreen := Self.ClientToScreen(Point(0, 0));
          OffsetRect(RectObjetoDeletado, PtScreen.X, PtScreen.Y);
          PossuiRectParaAvisar := True;
        end;
      end;
    end;

    if PossuiRectParaAvisar then
    begin
      ExibirHint('Ateno!', 'Este objeto no ser salvo. ' + #13 + 'Utilize o recurso '+
                 'apropriado do RRPG para importar imagens/objetos',
                 RectObjetoDeletado, 5000, 0);
    end else
      if DeletouObjeto then
      begin
        RectObjetoDeletado := Self.GetClientRect;
        PtScreen := Self.ClientToScreen(Point(0, 0));
        OffsetRect(RectObjetoDeletado, PtScreen.X, PtScreen.Y);

        ExibirHint('Ateno!', 'H objetos que sero excludos.' + #13 + 'Utilize o recurso '+
                   'apropriado do RRPG para importar imagens/objetos', RectObjetoDeletado, 5000, 0);
      end;
  end;
begin
  inherited;
  ApagarObjetosInapropriados();
end;

constructor TRDBRichEditFrame.Create(AOwner: TComponent);
begin
  Self.SpellCheck := True;
  Self.WantTabs := True;
  Self.ScrollBars := ssVertical;
  Self.HideSelection := False;
  inherited;
end;

end.
