unit RRPGModuloUtil;

interface

uses
  Windows;

function ObterURLParaUmaImagem(var UrlDestino: String; const URLInicial: String = ''): Boolean;

procedure ExibirHint(const Titulo, Conteudo: String; R: TRect; Tempo: Cardinal = 5000; Angulo: Single = 270; const HWNDRect: HWND = 0;
                     const Delay: Integer = 100; Prioridade: Integer = 0); overload;
procedure ExibirErro(const Titulo, Conteudo: String; R: TRect; Tempo: Cardinal = 5000; Angulo: Single = 270; const HWNDRect: HWND = 0); overload;
procedure FecharHint;


implementation

uses
  Dialogs;

var
  UtilObterURLParaUmaImagem: function (const URLInicial: PWideChar; const DestURL: PWideChar; var LengthDest: Integer): Boolean; stdcall;
  UtilExibirHint: procedure (const Titulo, Conteudo: PWideChar; R: TRect; Tempo: Cardinal = 5000; Angulo: Single = 270; const HWNDRect: HWND = 0;
                             const Delay: Integer = 100; Prioridade: Integer = 0); stdcall;
  UtilExibirErro: procedure (const Titulo, Conteudo: PWideChar; R: TRect; Tempo: Cardinal = 5000; Angulo: Single = 270; const HWNDRect: HWND = 0); stdcall;
  UtilFecharHint: procedure; stdcall;

procedure ExibirHint(const Titulo, Conteudo: String; R: TRect; Tempo: Cardinal = 5000; Angulo: Single = 270; const HWNDRect: HWND = 0;
                     const Delay: Integer = 100; Prioridade: Integer = 0); overload;
begin
  if Assigned(UtilExibirHint) then
    UtilExibirHint(PWideChar(Titulo), PWideChar(Conteudo), R, Tempo, Angulo, HWNDRect, Delay, Prioridade);
end;

procedure ExibirErro(const Titulo, Conteudo: String; R: TRect; Tempo: Cardinal = 5000; Angulo: Single = 270; const HWNDRect: HWND = 0); overload;
begin
  if Assigned(UtilExibirErro) then
    UtilExibirErro(PWideChar(Titulo), PWideChar(Conteudo), R, Tempo, Angulo, HWNDRect);
end;

procedure FecharHint;
begin
  if Assigned(UtilFecharHint) then
    UtilFecharHint();
end;

function ObterURLParaUmaImagem(var UrlDestino: String; const URLInicial: String = ''): Boolean;
var
  TempStr: WideString;
  L: Integer;
  TempURL: String;
begin
  if Assigned(UtilObterURLParaUmaImagem) then
  begin
    SetLength(TempStr, 1024);
    L := Length(TempStr);
    Result := UtilObterURLParaUmaImagem(PWideChar(WideString(URLInicial)),
                                        PWideChar(TempStr), L);
    SetLength(TempStr, L);
    URLDestino := String(TempStr);
  end else
  begin
    TempURL := URLInicial;
    Result := InputQuery('Escolha uma imagem', 'Digite a URL de uma imagem:', TempURL);
    UrlDestino := TempURL;
  end;
end;

procedure CarregarFuncoes;
var
  H: HMODULE;
begin
  H := GetModuleHandle(nil);

  if H <> 0 then
  begin
    @UtilObterURLParaUmaImagem := GetProcAddress(H, 'UtilObterURLParaUmaImagem');
    @UtilExibirHint := GetProcAddress(H, 'UtilExibirHint');
    @UtilExibirErro := GetProcAddress(H, 'UtilExibirErro');
    @UtilFecharHint := GetProcAddress(H, 'UtilFecharHint');
  end;
end;

initialization
  CarregarFuncoes();

end.
