unit RRPGPageControlEditor;

interface

uses
  DesignIntf, DesignEditors, RRPGPageControl, Dialogs;

type
  TRPageControlEditor = class(TComponentEditor)
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;


implementation

{ TRPageControlEditor }

procedure TRPageControlEditor.ExecuteVerb(Index: Integer);
var
  S: String;
begin
  case Index of
    0:
      if Self.Component is TRTabSheet then
        TRPageControl(TRTabSheet(Self.Component).Parent).NovaPagina('')
      else
        TRPageControl(Self.Component).NovaPagina('');
    1:
      if Self.Component is TRTabSheet then
        TRPageControl(TRTabSheet(Self.Component).Parent).RemoverPagina()
      else
        TRPageControl(Self.Component).RemoverPagina();
    2:
      if Self.Component is TRTabSheet then
      begin
        S := TRTabSheet(Self.Component).Caption;

        if S = '' then
          S := TRTabSheet(Self.Component).Name;

        if InputQuery('Caption', 'Digitar um caption para pgina', S) then
          TRTabSheet(Self.Component).Caption := S;
      end else
      begin
        S := TRPageControl(Self.Component).ActivePage.Caption;

        if S = '' then
          S := TRPageControl(Self.Component).ActivePage.Name;

        if InputQuery('Caption','Digitar um caption para pgina',S) then
          TRPageControl(Self.Component).ActivePage.Caption := S;
      end;
  end;
end;

function TRPageControlEditor.GetVerb(Index: Integer): String;
begin
  case Index of
    0: Result := '&Nova Pgina';
    1: Result := '&Remover Pgina';
    2: Result := '&Caption da Pgina';

    else
      Result := '';
  end;
end;

function TRPageControlEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;

end.
