unit RRPGTreeView;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, ComCtrls;

type
  TRTreeView = class(TTreeView)
  private
    FAfterRecreateWnd: TNotifyEvent;
  protected
    procedure ConfigurarVisual; virtual;
    procedure Loaded; override;
    procedure CreateWnd; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published
    property AfterRecreateWnd: TNotifyEvent read FAfterRecreateWnd write FAfterRecreateWnd;
  end;

implementation

uses
  RRPGColorScheme, UxTheme, Themes, RRPGDrawUtil;

{ TRTreeView }

procedure TRTreeView.ConfigurarVisual;
begin
  Self.Color := EsquemaAtual.CorWindow;
  Self.Font.Color := EsquemaAtual.CorTextoNormal;
end;

constructor TRTreeView.Create(AOwner: TComponent);
begin
  inherited;
  RegistrarNotScheme(Self, Self.ConfigurarVisual);
end;

procedure TRTreeView.CreateWnd;
begin
  inherited;

  if IsThemeEnabled and (Win32MajorVersion >= 6) then
    SetWindowTheme(Self.Handle, '', nil); // do not localize

  if Assigned(FAfterRecreateWnd) then
    FAfterRecreateWnd(Self);
end;

destructor TRTreeView.Destroy;
begin
  DesregistrarNotScheme(Self);
  inherited;
end;

procedure TRTreeView.Loaded;
begin
  inherited;
  Self.ConfigurarVisual();
end;

end.
